from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtWidgets import QFileDialog
from HelloPioneer1 import Ui_PioneerControl
import math
from tkinter import filedialog
import runpy
import time
import importlib
import os.path
import cv2
from pioneer_sdk import Pioneer
import numpy as np

pioneer_mini = Pioneer()
_translate = QtCore.QCoreApplication.translate
pyka = 1


def file_open(self):
    filename = filedialog.askopenfilename(initialdir="C:/Users/пк/Desktop/HelloPioneer",
                                          title="Select a File",
                                          filetypes=(("Python Files",
                                                      "*.py*"),
                                                     ("all files",
                                                      "*.*")))
    name = os.path.split(f'{filename}')
    importlib.import_module(f'{name[1]}')

def pyka():
    ui.rh = QtWidgets.QPushButton(PioneerControl)
    ui.rh.setGeometry(760, 70, 121, 41)
    ui.rh.setText(_translate("PioneerControl", "Right-h"))
    ui.rh.setObjectName("right-handed")
    ui.rh.show()

    ui.lh = QtWidgets.QPushButton(PioneerControl)
    ui.lh.setGeometry(900, 70, 121, 41)
    ui.lh.setText(_translate("PioneerControl", "Left-h"))
    ui.lh.setObjectName("left-handed")
    ui.lh.show()
    def rh():
        ui.rh.hide()
        ui.lh.hide()
        pyka = 0
    def lh():
        ui.rh.hide()
        ui.lh.hide()
        pyka = 1
    ui.rh.clicked.connect( rh )
    ui.lh.clicked.connect( lh )
def speed():
    ui.Slow = QtWidgets.QPushButton(PioneerControl)
    ui.Slow.setGeometry(610, 70, 121, 41)
    ui.Slow.setText(_translate("PioneerControl", "Slow"))
    ui.Slow.setObjectName("slow")
    ui.Slow.show()

    ui.Fast = QtWidgets.QPushButton(PioneerControl)
    ui.Fast.setGeometry(750, 70, 121, 41)
    ui.Fast.setText(_translate("PioneerControl", "fast"))
    ui.Fast.setObjectName("fast")
    ui.Fast.show()
    def fast():
        ui.Slow.hide()
        ui.Fast.hide()
        command_x = float(0)
        command_y = float(0)
        command_z = float(1)
        command_yaw = math.radians(float(0))
        increment_xy = float(0.5)
        increment_z = float(0.25)
        increment_deg = math.radians(float(90))
    def slow():
        ui.Slow.hide()
        ui.Fast.hide()
        command_x = float(0)
        command_y = float(0)
        command_z = float(1)
        command_yaw = math.radians(float(0))
        increment_xy = float(0.1)
        increment_z = float(0.05)
        increment_deg = math.radians(float(90))
    ui.Fast.clicked.connect( fast )
    ui.Slow.clicked.connect( slow )
    pass

def exit():
    sys.exit(app.exec_())

while True:
    if __name__ == "__main__":
        import sys
        app = QtWidgets.QApplication(sys.argv)
        PioneerControl = QtWidgets.QDialog()
        ui = Ui_PioneerControl()
        ui.setupUi(PioneerControl)
        PioneerControl.show()
    #LOgica
        ui.pushButton_5.clicked.connect( speed )
        ui.pushButton_4.clicked.connect( pyka )
        ui.pushButton_6.clicked.connect( file_open )
        sys.exit(app.exec_())
        camera_frame = cv2.imdecode(np.frombuffer(pioneer_mini.get_raw_video_frame(), dtype=np.uint8), cv2.IMREAD_COLOR)
        cv2.imshow('pioneer_camera_stream', camera_frame)
        key = cv2.waitKey(1)
        if key == 27:  # esc
            print('esc pressed')
            cv2.destroyAllWindows()
            pioneer_mini.land()
            break
        elif key == ord('w'):
            print('w')
            command_y += increment_xy
            new_command = True
        elif key == ord('s'):
            print('s')
            command_y -= increment_xy
            new_command = True
        elif key == ord('a'):
            print('a')
            command_x -= increment_xy
            new_command = True
        elif key == ord('d'):
            print('d')
            command_x += increment_xy
            new_command = True
        elif key == ord('q'):
            print('q')
            command_yaw += increment_deg
            new_command = True
        elif key == ord('e'):
            print('e')
            command_yaw -= increment_deg
            new_command = True
        elif key == ord('h'):
            print('h')
            command_z += increment_z
            new_command = True
        elif key == ord('l'):
            print('l')
            command_z -= increment_z
            new_command = True

        if new_command:
            pioneer_mini.go_to_local_point(x=command_x, y=command_y, z=command_z, yaw=command_yaw)
            new_command = False

sys.exit(app.exec_())